*!Version 2.0.0 9Aug05

*Changelog

*Version 2.0.0 from Version 1.0.0
*
* -- fix very bad mistake of failing to account for covariances
*



*purpose of this command is to get regression-like output for the difference of means of a set of vars by some dummy var


program define meandifs, eclas
	version 7.0

	preserve
	syntax varlist [if] [in] [fweight aweight], by(varname) [nodit nodic LIstwise]

	if "`if'"=="" { /* no if condition, so we need to make one that will work with & conditions below */
		local if "if 1 "
	} /* end of no if condition, so we need to make one that will work with & conditions below */


	/* have to do this after marksample, since it chgs weight local macro */
	if "`weight'" ~= "" { 
		local weight "[`weight'`exp']" 
	*	di "weight is '`weight''"
	} /* end of making weight local macro */

	qui count 
	local numobs = _result(1)

	tempvar one
	qui gen `one' = 1

	tempname mean1 mean0 v1 v0 meandif vdif zero n1 n0
	local numvars : word count `varlist'

	*creating matrices we will populate
	mat `mean1' = J(1,`numvars',0)
	mat `mean0' = J(1,`numvars',0)

	mat `n1' = J(1,`numvars',0)
	mat `n0' = J(1,`numvars',0)

	mat `v1' = diag(`mean1')
	mat `v0' = diag(`mean1')
	

	
	

	forvalues value = 0/1 { /* looping over by(varname) variable */

		if "`listwise'"=="listwise" { /* can use a shortcut here, since user wants a consistent sample */

			local iflocal "`if' & `by'==`value'"

			/* getting the means */
			mat vecaccum `mean`value'' = `one' `varlist' `weight' `iflocal' `in'
			mat `mean`value'' = `mean`value''[1,1..`numvars'] / `mean`value''[1,`numvars'+1] 
	
			/* getting the variances */
			qui mat accum `v`value'' = `varlist' `weight' if `by'==`value', deviations nocon
			local numobs`value' = _result(1)
			qui mat `v`value'' =  `v`value'' / (_result(1)*(_result(1)-2)) /* sqd bc get _totals_ out of mat accum */
		} 
		else { /* user wants to use all available data for each var, so we need to loop explicitly over each one */

			local row = 0
			foreach rowvar in `varlist' { /* have to loop over each var to handle missing obs separately */
				local row = `row' + 1

				local iflocal "`if' & `by'==`value'"

				*first we do the diagonal (i.e., variance) terms
				qui sum `rowvar' `weight' `iflocal' `in'
				local rowvarnum		      = _result(1)
				local rowvarmean              = _result(3)
				local rowvarvariance          = _result(4)

				mat `mean`value''[1,`row']    = `rowvarmean'
				mat `v`value''[`row',`row']   = `rowvarvariance'/`rowvarnum'
				mat `n`value''[1,`row']       = `rowvarnum'	/* saving number of obs */

				*now deal with off-diagonal (i.e., covariance) terms
				local column = 0
				foreach colvar in `varlist' { /* loop over each obs separately for columns of cov matrix */
					local column = `column' + 1

					tempname product
					qui gen `product' = `rowvar'*`colvar'

					*getting avg of product
					qui sum `product' `weight' `iflocal' `in'
					local productnum      = _result(1)
					local productmean     = _result(3)

					*getting avg of rowvar for obs not missing data on either rowvar or colvar
					qui sum `rowvar' `weight' `iflocal' & `product'<. `in'
					local rowvarnum      = _result(1)
					local rowvarmean     = _result(3)

					*getting avg of colvar for obs not missing data on either rowvar or colvar
					qui sum `colvar' `weight' `iflocal' & `product'<. `in'
					local colvarnum      = _result(1)
					local colvarmean     = _result(3)

                                        mat `v`value''[`row',`column'] = /*
						*/ (`productmean' - `colvarmean'*`rowvarmean')/`rowvarnum'

					if (`v`value''[`row',`column']~=0) & (`v`value''[`column',`row']~=0) /*
						*/ & `v`value''[`column',`row'] ~= `v`value''[`row',`column'] {
						di "Assymetry for rowvar=`rowvar' and colvar=`colvar':"
						di "rc element=" `v`value''[`row',`column']
						di "cr element=" `v`value''[`column',`row'] 
					} 

					drop `product'
				} /* end of looping over each obs separately for columns of cov matrix */

			} /* end of have to loop over each var so we can handle missing obs separately */

		} /* end of user wants to use all available data for each var, so we need to loop explicitly over each one */

		foreach var in `varlist' { /* constructing names local macros */
			if `value'==0 { /* control group names for mean */
				local namesc "`namesc' c:`var'"
			}
			else {
				local namest "`namest' t:`var'"
				local namesd "`namesd' d:`var'"
			} /* end of names */
		} /* end of constructing names local macros */

	
		/* naming matrices -- have to do this outside varlist loop */
		if `value'==0 { /* control group names */
			mat colnames `mean`value'' = `namesc'
			mat rownames `v`value''    = `namesc'
			mat colnames `v`value''    = `namesc'
		}
		else {
			mat colnames `mean`value'' = `namest'
			mat rownames `v`value''    = `namest'
			mat colnames `v`value''    = `namest'
		} /* end of names */
	} /* end of looping over by(varname) variable */

	mat `meandif' = `mean1' - `mean0'
	mat `vdif'    = `v1' + `v0'

	*use this mat for adding in blocks in constructing full cov matrix (with control, treatment, and dif)
	mat `zero' = J(`numvars',`numvars',0)	

	di in gr "Mean differences by indicator variable '`by''" _new
	di in gr "                                       `weight'" _new
	if "`numobs1'" ~= "" {
		di in gr "Number of obs with `by'==1: " in ye %8.0g `numobs1'
	}

	/* putting together the vector and matrix of results */
	if "`dit'" == "" & "`dic'" == "" { /* want all results */
		mat `meandif' = `mean1' , `mean0', `meandif'
		mat `vdif' = (`v1' , `zero' , `v1') \ (`zero' , `v0', -1*`v0') \ (`v1', -1*`v0', `vdif')
		mat colnames `meandif' = `namest' `namesc' `namesd'
		mat rownames `vdif' = `namest' `namesc' `namesd'
		mat colnames `vdif' = `namest' `namesc' `namesd'

		if "`numobs0'" ~= "" {
			di "Number of obs with `by'==0: " in ye %8.0g `numobs0' _new
		}
		di "(Treated and control means and mean differences)" 
	}
	else if "`dit'" == "" { /* want only the control and dif results */
		mat `meandif' = `mean0', `meandif'
		mat `vdif' = (`v0', -1*`v0') \ ( -`v0', `vdif')
		mat colnames `meandif' = `namesc' `namesd'
		mat rownames `vdif' = `namesc' `namesd'
		mat colnames `vdif' = `namesc' `namesd'
		di "Number of obs with `by'==0: " in ye %8.0g `numobs0' _new
		di "(Control means and mean differences only)" 
	}
	else if "`dic'" == "" { /* want only the treatment and dif results */
		mat `meandif' = `mean1', `meandif'
		mat `vdif' = (`v1', `v1') \ ( `v1', `vdif')
		mat colnames `meandif' = `namest' `namesd'
		mat rownames `vdif' = `namest' `namesd'
		mat colnames `vdif' = `namest' `namesd'
		di  "Number of obs with `by'==0: " in ye %8.0g `numobs0' _new
		di "(Treated means and mean differences only)"
	}
	else if "`dit'"~="" & "`dic'"~="" { /* want only the dif results */
		mat `meandif' = `meandif'
		mat `vdif' = `vdif'

		mat rownames `vdif' = `namesd'

		/* losing the equation name */
		local names : rownames `vdif'
		mat colnames `meandif' = `names'
		mat colnames `meandif' = _:
		mat rownames `vdif' = `names'
		mat rownames `vdif' = _:
		mat colnames `vdif' = `names'
		mat colnames `vdif' = _:

		di "Number of obs with `by'==0: " in ye %8.0g `numobs0' _new
		di "(Mean differences only)"
	} /* end of subsets of the results */

/*
	mat colnames `meandif' = `varlist'
	mat rownames `vdif'    = `varlist'
	mat colnames `vdif'    = `varlist'
*/

/*
	di
	di "Number of obs with `by'=1:  `numobs1'"
	di "Number of obs with `by'=0:  `numobs0'"
	di
*/

	tempname meandifsave vdifsave
	mat `meandifsave' = `meandif'
	mat `vdifsave' = `vdif'
	estimates post `meandif' `vdif'

	/* means */
	estimates matrix mean0 `mean0'
	estimates matrix mean1 `mean1'
	estimates matrix meandif  `meandifsave'

	/* variances */
	estimates matrix v0 `v0'
	estimates matrix v1 `v1'
	estimates matrix vdif `vdifsave'

	/* sample sizes */
	if "`listwise'"=="listwise" { /* making matrices with sample sizes in listwise case (all samples are same size) */
		mat `n0' = J(1,`numvars',`numobs0')
		mat `n1' = J(1,`numvars',`numobs1')
	}
	estimates matrix N0 `n0'
	estimates matrix N1 `n1'


	di
	estimates display

	restore
end




